
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>tcp为什么要三次握手，而不能二次握手？ / iVAN</title>

    <meta name="description" content="tcp为什么要三次握手，而不能二次握手？ 谢希仁版&lt;计算机网络&gt;中的例子是这样的,&quot;已失效的连接请求报文段&quot;的产生在这样一种情况下:client发出的第一个连接请求报文段并没有丢失,而是在某个网络结点长时间的滞留了,以致延误到连接释放以后的某个时间才到达server.本来这是一个早已失效的报文段.但server收到此失效的连接请求报文段后,就误认为是client再次发出的一个新的连接请求.于是就向client发出确认报文段,同意建立连接.假设不采用&quot;三次握手&quot;,那么只要server发出 ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">tcp为什么要三次握手，而不能二次握手？</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>谢希仁版《计算机网络》中的例子是这样的，“已失效的连接请求报文段”的产生在这样一种情况下：client发出的第一个连接请求报文段并没有丢失，而是在某个网络结点长时间的滞留了，以致延误到连接释放以后的某个时间才到达server。本来这是一个早已失效的报文段。但server收到此失效的连接请求报文段后，就误认为是client再次发出的一个新的连接请求。于是就向client发出确认报文段，同意建立连接。假设不采用“三次握手”，那么只要server发出确认，新的连接就建立了。由于现在client并没有发出建立连接的请求，因此不会理睬server的确认，也不会向server发送ack包。（校注：此时因为client没有发起建立连接请求，所以client处于CLOSED状态，接受到任何包都会丢弃，谢希仁举的例子就是这种场景。但是如果服务器发送对这个延误的旧连接报文的确认的同时，客户端调用connect函数发起了连接，就会使客户端进入SYN_SEND状态，当服务器那个对延误旧连接报文的确认传到客户端时，因为客户端已经处于SYN_SEND状态，所以就会使客户端进入ESTABLISHED状态，此时服务器端反而丢弃了这个重复的通过connect函数发送的SYN包，见第三个图。而连接建立之后，发送包由于SEQ是以被丢弃的SYN包的序号为准，而服务器接收序号是以那个延误旧连接SYN报文序号为准，导致服务器丢弃后续发送的数据包）但server却以为新的运输连接已经建立，并一直等待client发来数据。这样，server的很多资源就白白浪费掉了。采用“三次握手”的办法可以防止上述现象发生。例如刚才那种情况，client不会向server的确认发出确认。server由于收不到确认，就知道client并没有要求建立连接。</p>
<p>在谢希仁著《计算机网络》第四版中讲“三次握手”的目的是“为了防止已失效的连接请求报文段突然又传送到了服务端，因而产生错误”。在另一部经典的《计算机网络》（Andrew<br />
 S.Tanenbaum著，第四版）一书中讲“三次握手”的目的是为了解决“网络中存在延迟的重复分组”的问题。这两种不同的表述其实阐明的是同一个问题。</p>
<p>   <img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDAyMTEyMTE0MzQxMDk/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2ZUhWdGFXNHpNekEzTnpReU16TT0vZm9udC81YTZMNUwyVC9mb250c2l6ZS80MDAvZmlsbC9JMEpCUWtGQ01BPT0vZGlzc29sdmUvNzAvZ3Jhdml0eS9DZW50ZXI=.jpg"></p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDAyMTEyMzI2MzgyOTY/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2ZUhWdGFXNHpNekEzTnpReU16TT0vZm9udC81YTZMNUwyVC9mb250c2l6ZS80MDAvZmlsbC9JMEpCUWtGQ01BPT0vZGlzc29sdmUvNzAvZ3Jhdml0eS9DZW50ZXI=.jpg"></p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDAyMTEyMzI1NDg4MTI/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2ZUhWdGFXNHpNekEzTnpReU16TT0vZm9udC81YTZMNUwyVC9mb250c2l6ZS80MDAvZmlsbC9JMEpCUWtGQ01BPT0vZGlzc29sdmUvNzAvZ3Jhdml0eS9DZW50ZXI=.jpg"></p>
<p>附华中科技大学有一题研究生入学考题，是下面题目的中文翻译版(不过我觉得这个答案有点牵强，毕竟现在tcp传输机制中都有定时器，会有超时重传，不会导致死锁的，当然如果没有超时机制，死锁还是可能的）：</p>
<p><strong>Imagine that a two-way handshake rather than a three-way handshake were used to set up connections. In other words, the third message was not required. Are deadlocks now possible? Give an example or show that none exist.</p>
<p>Answer:<br /></strong>Deadlocks are possible. For example, a packet arrives at A out of the blue, and A acknowledges it. The acknowledgement gets lost, but A is now open while B knows nothing at all about what has happened. Now the same thing happens to B, and both are<br />
 open, but expecting different sequence numbers. Timeouts have to be introduced to avoid the deadlocks.</p>
<p>网上有一段流传很广的解释：</p>
<p><strong> 为什么不能用两次握手进行连接？</strong></p>
<p>我们知道，3次握手完成两个重要的功能，既要双方做好发送数据的准备工作(双方都知道彼此已准备好)，也要允许双方就初始序列号进行协商，这个序列号在握手过程中被发送和确认。<br />
    现在把三次握手改成仅需要两次握手，死锁是可能发生的。作为例子，考虑计算机S和C之间的通信，假定C给S发送一个连接请求分组，S收到了这个分组，并发 送了确认应答分组。按照两次握手的协定，S认为连接已经成功地建立了，可以开始发送数据分组。可是，C在S的应答分组在传输中被丢失的情况下，将不知道S 是否已准备好，不知道S建立什么样的序列号，C甚至怀疑S是否收到自己的连接请求分组。在这种情况下，C认为连接还未建立成功，将忽略S发来的任何数据分 组，只等待连接确认应答分组。而S在发出的分组超时后，重复发送同样的分组。这样就形成了死锁。</p>
<p>校评：这个解释也值得商榷，这里指说S超时重传，难道C没有收到S的ACK信号，不会重新发送SYN信号么？ 只要重新发送SYN，S端自然也会发送确认应答分组，这样就不会导致死锁。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-14 06:39:18</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar">

		<h3>tcp为什么要三次握手，而不能二次握手？的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/ze7Vo8M.html" rel="bookmark">【转载】理解TCP为什么需要进行三次握手&lpar;白话&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				理解TCP为什么需要进行三次握手(白话)   首先简单介绍一下TCP三次握手   www.2cto.com       在TCP/IP协议中,TCP协议提供可靠的连接服务,采用三次握手建立一个连接.   第一次握手:建立连接时,客户端发送syn包(syn=j)到服务器,并进入SYN_SEND状态,等待服务器确认:   第二次握手:服务器收到syn包,必须确认客户的SYN(ack=j+1),同时自己也发送一个SYN包(syn=k),即SYN+ACK包,此时服务器 进入SYN_RECV状态:   第			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M0QmV8p.html" rel="bookmark">结合Wireshark捕获分组深入理解TCP&sol;IP协议栈之TCP协议&lpar;TCP报文格式&plus;三次握手实例&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				摘要:     本文简单介绍了TCP面向连接理论知识,详细讲述了TCP报文各个字段含义,并从Wireshark俘获分组中选取TCP连接建立相关报文段进行分析.   一.概述     TCP是面向连接的可靠传输协议,两个进程互发数据之前需要建立连接,这里的连接只不过是端系统中分配的一些缓存和状态变量,中间的分组交换机不维护任何连接状态信息.连接建立整个过程如下(即三次握手协议): 首先,客户机发送一个特殊的TCP报文段: 其次,服务器用另一个特殊的TCP报文段来响应: 最后,客户机再用第三个特殊报			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pkwv15p.html" rel="bookmark">TCP连接建立的三次握手过程可以携带数据吗？</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前几天实验室的群里扔出了这样一个问题:TCP连接建立的三次握手过程可以携带数据吗?突然发现自己还真不清楚这个问题,平日里用tcpdump或者Wireshark抓包时,从来没留意过第三次握手的ACK包有没有数据.于是赶紧用nc配合tcpdump抓了几次包想检验一下.但是经过了多次实验,确实都发现第三次握手的包没有其它数据(后文解释).后来的探究中发现这个过程有问题,遂整理探究过程和结论汇成本文,以供后来者参考. 先来张三次握手的图(下面这张图来自网络,若侵犯了作者权利,请联系我删除): RFC79			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zGAnV3M.html" rel="bookmark">参数-三种传参，操纵二维数组</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 三种传参,操纵二维数组 利用三种不同的方式在函数参数中,传递二维数组: void func(int **a,int m,int n); 利用二级指针 void func(int *a[],int m,int n); 利用一维指针数组 void func(int a[][10],int m,int n); 利用二维数组 请问:那种方式可以在函数func中通过参数a操纵传递进的二维数组?如果不能,原因是什么? 解决方案 下面这俩是等价的: void func(int **a,int m,i			</div>
		</article>
	</section>
						<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/xpnxjWb.html" rel="bookmark">深入浅出TCP协议的三次握手过程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				TCP是主机对主机层的传输控制协议,提供可靠的连接服务,采用三次握手确认建立一个连接: 每一次TCP连接都需要三个阶段:连接建立.数据传送和连接释放.&quot;三次握手&quot;就发生在连接建立阶段. 1.三次握手(three times handshake) 所谓的&quot;三次握手&quot;即对每次发送的数据量跟踪进行协商使数据段的发送和接收同步,以及根据所接收到的数据量来确定数据发送.接收完毕后何时撤消联系,并建立虚连接. 第一次握手:主机A发送位码为syn＝1,随机产生seq number			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/aM12KKp.html" rel="bookmark">TCP中的三次握手和四次挥手</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.文章来由 三次握手只记得ack.ack+1这些零碎片段了~~~特此总结 二.总图 明显三次握手是建立连接,四次挥手是断开连接,总图如下: 三.握手 (1)首先,Client端发送连接请求报文(SYN=1,seq=client_isn) (2)Server段接受连接后回复ACK报文,并为这次连接分配资源.(SYN=1,seq=client_isn,ack = client_isn+1) (3)Client端接收到ACK报文后也向Server段发生ACK报文,并分配资源,这样TCP连接就建立了.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pn7VeAz.html" rel="bookmark">TCP连接的三次握手（基于WIRESHARK抓包分析）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				作为一个IT人士,如果能TCP的三次握手都不知道长什么样子, 那也算是白混了.它或许只是一种掉书袋的知识,对真正解决问题帮助不是最大.(异常数据包才是分析重点) 这次记录一下它的样子吧. 记住两次ACK值都是在SEQ的基础上+1来实现认证的.还有,哪些过程有SYN标记,哪些过程同时有SYN+ACK标记,哪些过程只有ACK标记. 此处略过前面的DNS请求和后面的GET/HTTP1.1过程..  			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MR70Wxp.html" rel="bookmark">豫商集团三度举牌&OpenCurlyDoubleQuote;坐二望一&rdquo;东方银星或易主</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				小盘股东方银星(600753,收盘价12.09元)或将&quot;改换门庭&quot;!继6月7日.6月25日两度遭豫商集团举牌之后,今日该公司宣布豫商集团的持股比例已达15%,与大股东重庆银星的持股量仅相差约6个百分点.豫商集团来势如此汹汹,其目的已经跃然纸上--取东方银星大股东地位而代之.仍宣称股权投资东方银星今日公告,近日公司接到豫商集团书面报告,该集团已于7月2日至7月12日期间,通过上证所交易系统增持公司股份640万股,占公司总股本的5%.截至7月12日,豫商集团累计持有公司1920万股,占公司			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MR4R1kz.html" rel="bookmark">认房又认贷三部门出台最严厉二套房政策</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				依据拟购房家庭(包括借款人.配偶及未成年子女)成员名下实际拥有的成套住房数量进行认定 [财新网](记者 鲍有斌 4日发自北京) 住房和城乡建设部.中国人民银行.银监会联合发出通知,对商业性个人住房贷款中第二套住房认定标准进行规范:商业性个人住房贷款中居民家庭住房套数,应依据拟购房家庭(包括借款人.配偶及未成年子女)成员名下实际拥有的成套住房数量进行认定. 6月4日,住房和城乡建设部网站发布了&lt;关于规范商业性个人住房贷款中第二套住房认定标准的通知&gt;. 国务院近期决定,对贷款购买第二套住房的家庭,			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/xpnQxkM.html" rel="bookmark" class="title">PS情侣照片&colon;白皙动人的糖水效果</a>
					<div>
						非常感谢老兵黑影提供的原片 本教程图片比较大,如果您看不清楚,可以点击图片看大图. 这张是最后处理好的效果,大家可以对比一下,如果喜欢的话可以继续看我说的步骤 [1] [2] [3]  下一页					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/XMloBab.html" rel="bookmark" class="title">Flash视频教程实例：橡皮擦的应用</a>
					<div>
						教程|视频教程 制作步骤:(全屏观看教程)					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/xp83E4M.html" rel="bookmark" class="title">SEO成为鸡肋 笑到最后才会剩者为王</a>
					<div>
						&quot;我的这个站就像鸡肋,食之无味,弃之不舍&quot;,一位希望靠淘宝客网站实现&quot;网赚梦&quot;的朋友对A5站长网SEO团队(www.yuehuai.com)负责人唐世军说:&q ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/gpko8jp.html" rel="bookmark" class="title">蒋晖回应利为汇seo站被K原因</a>
					<div>
						自从谷歌更新了PR后,百度就没安静过.特别是 最近SEO界动荡不安,犹如进入上海滩,有乱世出英雄,也有昙花一现的,更有江湖大佬-利为汇被K,而且一锅端.外界众说风云,有对的,也有错的.但是利为汇当家人 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgKPnAM.html" rel="bookmark" class="title">暴风影音2&period;0让播放更清晰流畅</a>
					<div>
						暴风影音2.0具备了一种名为&quot;MEE媒体专家引擎&quot;,据称,它是多播放核心.多渲染方式的有机结合. 依次开启&quot;文件→打开方式(高级)&quot;命令,便能够在&quot;高 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRyXjab.html" rel="bookmark" class="title">PHP开发框架Yii Framework教程&lpar;16&rpar; UI 组件 StarRating示例</a>
					<div>
						CStarRating 主要用于评分,显示一组星星(5 个)用于打分. 基本用法如下 &lt;center class=&quot;form&quot;&gt; &lt;?php $form=$thi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrKad6p.html" rel="bookmark" class="title">顺序表的实现示例</a>
					<div>
						线性表的顺序实现例子 .h文件 此文件为方法 #ifndef SQLIST_H_INCLUDED #define SQLIST_H_INCLUDED #include &quot;ds.h&quot; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgKvlEM.html" rel="bookmark" class="title">CSS中id和class的区别和用法</a>
					<div>
						在一个网页里ID只能使用一次.当然即使一个id在一个网页内被使用多次,其CSS样式仍然可以实现生效,但是一般规定W3C标准是使用一次.因为ID在html里可以赋予html标签特殊的属性如一下JS动作. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxWoRmb.html" rel="bookmark" class="title">Win10如何禁用系统视觉动画效果以兼容较老机器</a>
					<div>
						  有些用户使用的电脑较老,硬件配置较为落后,尤其是显卡.他们想要流畅使用Win10系统,必须牺牲一些高级视觉特性,比如动画效果.这该如何设置呢? 操作步骤 1.打开控制面板. 2.选择轻松使用. 主 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mr32Avp.html" rel="bookmark" class="title">路由器故障维修方法</a>
					<div>
						  1.如果说明上和路由器上显示的都不行的话,用下面的方法可以试一试,首先将IP设置为自动获取,开始---运行-- cmd,输入:ipconfig/all,查看一下Default Gateway那一行 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0W6NJb.html" rel="bookmark" class="title">应用宝百家CP联合大拜年下载有奖活动</a>
					<div>
						  腾讯应用宝携手众多安卓应用贺新春,只要点点按钮一键下载就可以免费拿海量QQ币奖品哟!总计可以得到84次得奖机会(虽然得奖概率不是很高哈),抽奖机会多多,足以让你抽到手抽筋,赶快碰碰手气呗! 活动地 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJZK56z.html" rel="bookmark" class="title">Windows7音频服务未运行怎么办？</a>
					<div>
						  Windows7音频服务未运行的解决办法 解决方法1.Windows7&quot;音频服务未运行&quot;,有个红色小叉咋办?网友支招简单做法:点小喇叭,把音量放到最大 解决方法2.window ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6e5Job.html" rel="bookmark" class="title">禁用了U盘还能用U盘装系统吗</a>
					<div>
						在别人的电脑上使用U盘时不小心感染了病毒,自己就照着网上的方法在自己的电脑上禁用了U盘启动,但问题就来了,因为网友有时重装系统时也是用U盘来重装的,如果禁用了之后,不就不可以用U盘来装系统了吗?下面就 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOa6yxM.html" rel="bookmark" class="title">数据恢复工程师深度拆解BMP文件格式</a>
					<div>
						BMP是一种与硬件设备无关的图像文件格式,使用非常广.它采用位映射存储格式,除了图像深度可选以外,不采用其他任何压缩,因此,BblP文件所占用的空间很大.BMP文件的图像深度可选lbit.4bit.8 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6NeKWM.html" rel="bookmark" class="title">查询问题 急急急-查询两个表的数据，然后第一个表的数据存在相同时，则只显示一行，其他的显示为空</a>
					<div>
						问题描述 查询两个表的数据,然后第一个表的数据存在相同时,则只显示一行,其他的显示为空 如上图,第一个表的字段包含 内码.编号.客户.日期,第二个表包含出库单等字段,现在查询出来的数据,只要内码相同, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkwJGyp.html" rel="bookmark" class="title">link环境下制作的一款《网盘软件》，如何分成3个服务器上传？怎么互相连接？</a>
					<div>
						问题描述 link环境下制作的一款&lt;网盘软件&gt;,如何分成3个服务器上传?怎么互相连接? link环境下制作的一款&lt;网盘软件&gt;,如何分成3个服务器上传?怎么互相连接? 解决方案  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJAxV6p.html" rel="bookmark" class="title">cmd ren命令 重命名文件（夹）&lowbar;DOS&sol;BAT</a>
					<div>
						ren 的用法很简单,其使用格式为:ren 旧文件 新文件名.例如,把test.txt改写为abc.txt,使用 ren test.txt abc.txt即可. 需要注意的是,旧文件可以使用绝对路径, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnKr8jz.html" rel="bookmark" class="title">哪位前辈了解南京磐能电力啊？能说一下在这家公司做软件开发怎样嘛？谢谢啊</a>
					<div>
						问题描述 我是应届本科生,拿到了这家公司的Offer?想了解下这家公司做软件开发的发展前景,以及这家公司除了基本工资,还有什么福利待遇没有?先谢谢大家了! 解决方案 虽然我人在南京但没有听过这家公司, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqR3Rep.html" rel="bookmark" class="title">2012网络技术趋势之网络安全与网络管理</a>
					<div>
						2012年http://www.aliyun.com/zixun/aggregation/12311.html&quot;&gt;网络技术趋势是什么?本站采访了Gartner副总裁GregYoung, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2RNXrb.html" rel="bookmark" class="title">图片-文字下面线和文字一致</a>
					<div>
						问题描述 文字下面线和文字一致 项目中这个界面我想让文字下面的线和textview一直-求大神指导 解决方案 找到页签的布局,或代码,里面肯定有线的设置,改了就行,如果没源码,那就算了					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQBenOM.html" rel="bookmark" class="title">android-Android数据库内存溢出的问题</a>
					<div>
						问题描述 Android数据库内存溢出的问题 请问Android编译时出现这个问题:out of memory on a 1900-byte allocation怎么解决? 解决方案 看下图片是不是过 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8A4KNz.html" rel="bookmark" class="title">C&num; 乱码</a>
					<div>
						问题描述 鍏抽棴这是什么编码啊?我知道中文解出来应该是关闭的意思,但要怎么解,试了都不对还有ENGDTS5.1CH768kbps-[鑻辫]正确的应该是ENGDTS5.1CH768kbps-[英文]  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/baB2WgM.html" rel="bookmark" class="title">xlistview-安卓有关的代码 有关Xlistview</a>
					<div>
						问题描述 安卓有关的代码 有关Xlistview private void initView(View parentView) { xListView = (XListView) parentView ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRN0RkM.html" rel="bookmark" class="title">《Python游戏编程快速上手》&mdash;&mdash;导读</a>
					<div>
						前 言 感谢您阅读本书.编写本书最初的动机是,我看到目前很少有能够激发孩子学习编程的兴趣的图书.我最初使用BASIC编程语言开始编程,使用的是一本像本书一样的书. 在写作本书的过程中,我意识到,像Py ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOnJ45p.html" rel="bookmark" class="title">详解iOS开发中的转场动画和组动画以及UIView封装动画&lowbar;IOS</a>
					<div>
						一.转场动画 CAAnimation的子类,用于做转场动画,能够为层提供移出屏幕和移入屏幕的动画效果.iOS比Mac OS X的转场动画效果少一点 UINavigationController就是通过 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2Zk6Vb.html" rel="bookmark" class="title">javascript 特性检测并非浏览器检测&lowbar;javascript技巧</a>
					<div>
						我大致翻译了部分文章,可能有理解错误的地方,敬请指正.值得一提的是,评论部分的争论亦值得一看. 特性检测 起初前端工程师们就极力反对浏览器检测,他们认为类似user-agent嗅探的方法是很不好的,理 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6GmlNp.html" rel="bookmark" class="title">浅谈jQuery hover&lpar;over&comma; out&rpar;事件函数&lowbar;jquery</a>
					<div>
						hover(over, out)事件函数 当鼠标移动一个匹配的元素上面,会触发指定的第一个函数 当鼠标移出这个元素时,会触发指定的第二个函数 over(function):鼠标移到元素上触发的函数 o ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqWEqkz.html" rel="bookmark" class="title">2016迅雷&sol;乐视&sol;爱奇艺免费会员领取10月9日更新</a>
					<div>
						2016 10月9日乐视vip账号分享 账号18682251209密码:5567065 账号:18611934443密码:8236722jin 账号18074073880密码:dyp99sjzad 账 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze0VGjp.html" rel="bookmark" class="title">asp 创建文件与文件夹</a>
					<div>
						'==============================  '函 数 名:CreateFolder  '作    用:创建文件夹  '参    数:文件夹相对路径FolderPath  '=== ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdvm3Nb.html" rel="bookmark" class="title">Windows Server 2008终端服务&lpar;Terminal Services&rpar;指南</a>
					<div>
						一.终端服务(Terminal Services)简介 终端服务是http://www.aliyun.com/zixun/aggregation/32995.html&quot;&gt;在Window ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.028 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
